=begin
#No descripton provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 

Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require 'date'

module QwilAPI

  class ManagerPlatformSerializer
    attr_accessor :url

    attr_accessor :name

    attr_accessor :contact_information

    attr_accessor :company_information

    attr_accessor :contractors

    # The ISO 4217 currency code for which all payments for this Platform are handled. Note: Immutable after Platform is created.
    attr_accessor :currency

    attr_accessor :income

    attr_accessor :invoices

    attr_accessor :create_invoice

    # The frequency of contractor rebates on this platform.
    attr_accessor :payment_schedule

    # The date that the first payment is due for the platform's pay cycle.
    attr_accessor :payment_date

    # The accounts configured for billing on this Platform.
    attr_accessor :accounts

    # The account to use for billing purposes.
    attr_accessor :default_account

    attr_accessor :manager

    # URL of the list of Platform Memberships.
    attr_accessor :memberships

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'url' => :'url',
        :'name' => :'name',
        :'contact_information' => :'contact_information',
        :'company_information' => :'company_information',
        :'contractors' => :'contractors',
        :'currency' => :'currency',
        :'income' => :'income',
        :'invoices' => :'invoices',
        :'create_invoice' => :'create_invoice',
        :'payment_schedule' => :'payment_schedule',
        :'payment_date' => :'payment_date',
        :'accounts' => :'accounts',
        :'default_account' => :'default_account',
        :'manager' => :'manager',
        :'memberships' => :'memberships'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'url' => :'String',
        :'name' => :'String',
        :'contact_information' => :'ContactInformationSerializer',
        :'company_information' => :'CompanyInformationSerializer',
        :'contractors' => :'String',
        :'currency' => :'String',
        :'income' => :'String',
        :'invoices' => :'String',
        :'create_invoice' => :'String',
        :'payment_schedule' => :'String',
        :'payment_date' => :'Date',
        :'accounts' => :'Array<String>',
        :'default_account' => :'String',
        :'manager' => :'String',
        :'memberships' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'url')
        self.url = attributes[:'url']
      end

      if attributes.has_key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.has_key?(:'contact_information')
        self.contact_information = attributes[:'contact_information']
      end

      if attributes.has_key?(:'company_information')
        self.company_information = attributes[:'company_information']
      end

      if attributes.has_key?(:'contractors')
        self.contractors = attributes[:'contractors']
      end

      if attributes.has_key?(:'currency')
        self.currency = attributes[:'currency']
      end

      if attributes.has_key?(:'income')
        self.income = attributes[:'income']
      end

      if attributes.has_key?(:'invoices')
        self.invoices = attributes[:'invoices']
      end

      if attributes.has_key?(:'create_invoice')
        self.create_invoice = attributes[:'create_invoice']
      end

      if attributes.has_key?(:'payment_schedule')
        self.payment_schedule = attributes[:'payment_schedule']
      end

      if attributes.has_key?(:'payment_date')
        self.payment_date = attributes[:'payment_date']
      end

      if attributes.has_key?(:'accounts')
        if (value = attributes[:'accounts']).is_a?(Array)
          self.accounts = value
        end
      end

      if attributes.has_key?(:'default_account')
        self.default_account = attributes[:'default_account']
      end

      if attributes.has_key?(:'manager')
        self.manager = attributes[:'manager']
      end

      if attributes.has_key?(:'memberships')
        self.memberships = attributes[:'memberships']
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @url.nil?
      return false if @name.nil?
      return false if @contact_information.nil?
      return false if @company_information.nil?
      return false if @contractors.nil?
      return false if @currency.nil?
      currency_validator = EnumAttributeValidator.new('String', ["USD", "GBP"])
      return false unless currency_validator.valid?(@currency)
      return false if @income.nil?
      return false if @invoices.nil?
      return false if @create_invoice.nil?
      return false if @payment_schedule.nil?
      payment_schedule_validator = EnumAttributeValidator.new('String', ["WEEKLY", "FORTNIGHT", "MONTHLY", "DAILY"])
      return false unless payment_schedule_validator.valid?(@payment_schedule)
      return false if @payment_date.nil?
      return false if @accounts.nil?
      return false if @default_account.nil?
      return false if @manager.nil?
      return false if @memberships.nil?
      return true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] currency Object to be assigned
    def currency=(currency)
      validator = EnumAttributeValidator.new('String', ["USD", "GBP"])
      unless validator.valid?(currency)
        fail ArgumentError, "invalid value for 'currency', must be one of #{validator.allowable_values}."
      end
      @currency = currency
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] payment_schedule Object to be assigned
    def payment_schedule=(payment_schedule)
      validator = EnumAttributeValidator.new('String', ["WEEKLY", "FORTNIGHT", "MONTHLY", "DAILY"])
      unless validator.valid?(payment_schedule)
        fail ArgumentError, "invalid value for 'payment_schedule', must be one of #{validator.allowable_values}."
      end
      @payment_schedule = payment_schedule
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          url == o.url &&
          name == o.name &&
          contact_information == o.contact_information &&
          company_information == o.company_information &&
          contractors == o.contractors &&
          currency == o.currency &&
          income == o.income &&
          invoices == o.invoices &&
          create_invoice == o.create_invoice &&
          payment_schedule == o.payment_schedule &&
          payment_date == o.payment_date &&
          accounts == o.accounts &&
          default_account == o.default_account &&
          manager == o.manager &&
          memberships == o.memberships
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [url, name, contact_information, company_information, contractors, currency, income, invoices, create_invoice, payment_schedule, payment_date, accounts, default_account, manager, memberships].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = QwilAPI.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
