=begin
#No descripton provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 

Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require 'date'

module QwilAPI

  class WriteUserAccountSerializer
    attr_accessor :account_number

    # The user's label for this Account.
    attr_accessor :name

    # The inter-bank routing nubmer for this Account. 8 or 9 digits in length.
    attr_accessor :routing_number

    # Flag specifying if the Account is a Paypal account.
    attr_accessor :is_paypal

    # Flag specifying if the Account is a MyChoice card. If it is, the mychoice_user_id and mychoice_card_id must be filled in.
    attr_accessor :is_mychoice

    # For MyChoice Accounts. Populated from the MyChoice API.
    attr_accessor :mychoice_user_id

    # For MyChoice Accounts. Populated from the MyChoice API.
    attr_accessor :mychoice_card_id


    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'account_number' => :'account_number',
        :'name' => :'name',
        :'routing_number' => :'routing_number',
        :'is_paypal' => :'is_paypal',
        :'is_mychoice' => :'is_mychoice',
        :'mychoice_user_id' => :'mychoice_user_id',
        :'mychoice_card_id' => :'mychoice_card_id'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'account_number' => :'String',
        :'name' => :'String',
        :'routing_number' => :'String',
        :'is_paypal' => :'BOOLEAN',
        :'is_mychoice' => :'BOOLEAN',
        :'mychoice_user_id' => :'Integer',
        :'mychoice_card_id' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'account_number')
        self.account_number = attributes[:'account_number']
      end

      if attributes.has_key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.has_key?(:'routing_number')
        self.routing_number = attributes[:'routing_number']
      end

      if attributes.has_key?(:'is_paypal')
        self.is_paypal = attributes[:'is_paypal']
      end

      if attributes.has_key?(:'is_mychoice')
        self.is_mychoice = attributes[:'is_mychoice']
      end

      if attributes.has_key?(:'mychoice_user_id')
        self.mychoice_user_id = attributes[:'mychoice_user_id']
      end

      if attributes.has_key?(:'mychoice_card_id')
        self.mychoice_card_id = attributes[:'mychoice_card_id']
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new

      if !@mychoice_user_id.nil? && @mychoice_user_id > 2.147483647E9
        invalid_properties.push("invalid value for 'mychoice_user_id', must be smaller than or equal to 2.147483647E9.")
      end

      if !@mychoice_user_id.nil? && @mychoice_user_id < -2.147483648E9
        invalid_properties.push("invalid value for 'mychoice_user_id', must be greater than or equal to -2.147483648E9.")
      end


      if !@mychoice_card_id.nil? && @mychoice_card_id > 9.223372036854776E18
        invalid_properties.push("invalid value for 'mychoice_card_id', must be smaller than or equal to 9.223372036854776E18.")
      end

      if !@mychoice_card_id.nil? && @mychoice_card_id < -9.223372036854776E18
        invalid_properties.push("invalid value for 'mychoice_card_id', must be greater than or equal to -9.223372036854776E18.")
      end

      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @account_number.nil?
      return false if @name.nil?
      return false if @routing_number.nil?
      return false if !@mychoice_user_id.nil? && @mychoice_user_id > 2.147483647E9
      return false if !@mychoice_user_id.nil? && @mychoice_user_id < -2.147483648E9
      return false if !@mychoice_card_id.nil? && @mychoice_card_id > 9.223372036854776E18
      return false if !@mychoice_card_id.nil? && @mychoice_card_id < -9.223372036854776E18
      return true
    end

    # Custom attribute writer method with validation
    # @param [Object] mychoice_user_id Value to be assigned
    def mychoice_user_id=(mychoice_user_id)

      if !mychoice_user_id.nil? && mychoice_user_id > 2.147483647E9
        fail ArgumentError, "invalid value for 'mychoice_user_id', must be smaller than or equal to 2.147483647E9."
      end

      if !mychoice_user_id.nil? && mychoice_user_id < -2.147483648E9
        fail ArgumentError, "invalid value for 'mychoice_user_id', must be greater than or equal to -2.147483648E9."
      end

      @mychoice_user_id = mychoice_user_id
    end

    # Custom attribute writer method with validation
    # @param [Object] mychoice_card_id Value to be assigned
    def mychoice_card_id=(mychoice_card_id)

      if !mychoice_card_id.nil? && mychoice_card_id > 9.223372036854776E18
        fail ArgumentError, "invalid value for 'mychoice_card_id', must be smaller than or equal to 9.223372036854776E18."
      end

      if !mychoice_card_id.nil? && mychoice_card_id < -9.223372036854776E18
        fail ArgumentError, "invalid value for 'mychoice_card_id', must be greater than or equal to -9.223372036854776E18."
      end

      @mychoice_card_id = mychoice_card_id
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          account_number == o.account_number &&
          name == o.name &&
          routing_number == o.routing_number &&
          is_paypal == o.is_paypal &&
          is_mychoice == o.is_mychoice &&
          mychoice_user_id == o.mychoice_user_id &&
          mychoice_card_id == o.mychoice_card_id
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [account_number, name, routing_number, is_paypal, is_mychoice, mychoice_user_id, mychoice_card_id].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = QwilAPI.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
